/*

First things first:

1. Run TC.
2. Press Alt-O.
3. Press C.
4. Press C.
5. Press Tab.
6. Make sure that Treat enum as ints does not have an X next to it.
7. Save your settings.

If you are running another compiler,  make sure that you take the appropriate
steps or the size  of the files won't match  and you will cause great harm to
the file that you're working on. If you ignore this warning, you will have no
one to blame but yourself.

	      ͻ
	       Structures document for  QuickBBS  version 2.80. 
	       This information  may be freely copied  and used 
	       at no charge  by any  party to  write  utilities 
	       and other  software  which  enhances  the use of 
	       the QuickBBS  software.  Use of this information 
	       in any other BBS program is strictly prohibited. 
	                                                        
	              Copyright 1991-95 Pegasus Software        
	                                                        
	                     All Rights Reserved.               
	                                                        
	                  Translation by Ed Grinnell            
	      ͼ   */

#include "QTypes.hpp"

/* USERIDX.BBS or USERIDX.DAT */

struct  UserIdxRecord
	{
	LongInt         NameCRC;
	LongInt         AliasCRC;
	};

/* USERS.BBS or USERS.DAT */

struct  UserRecord
	{
	StringDef35     Name;
	StringDef25     City;
	Byte            ReservedZero;
	Byte            Language;
	LongInt         PwdCrc;
	Word            PwdChangeDate;
	Word            ExpireDate;
#ifdef GOLDBASE
	LongInt         HighMsgRead;
#else
	LongInt         UnusedSpace;

#endif
	Byte            ExtraSpace[2];
	StringDef12     DataPhone;
	StringDef12     HomePhone;
	StringDef5      LastTime;
	StringDef8      LastDate;
	Byte            Attrib;
	FlagType        Flags;
	Word            Credit;
	Word            Pending;
#ifdef GOLDBASE
	Word            TimesPosted;
	Word            ObsoleteField;
#else
	Word            TimesPosted;
	Word            HighMsgRead;
#endif
	Word            SecLvl;
	Word            Times;
	Word            Ups;
	Word            Downs;
	Word            UpK;
	Word            DownK;
	Integer         TodayK;
	Integer         Elapsed;
	Integer         Len;
	Word            CombinedPtr;
	Word            AliasPtr;
	LongInt         Birthday;
	};

/*      Attrib:

	Bit 0: Deleted
	Bit 1: Screen Clear Codes
	Bit 2: More Prompt
	Bit 3: ANSI
	Bit 4: No-Kill
	Bit 5: Ignore Download Hours
	Bit 6: ANSI Full Screen Editor
	Bit 7: Sex (0=male, 1=female)
*/

/* USERON.BBS */

struct  USERONrecord
	{
	StringDef35             Name;
	StringDef35             Alias;
	Byte                    Line;
	Word                    Baud;
	StringDef25             City;
	Boolean                 DoNotDisturb;
	Byte                    Conference;
	UserActivityType        Activity;
	Byte                    Language;
	Byte                    Spare[8];
	};

/* ALIAS.BBS */

struct  AliasRecord
	{
	StringDef35     AliasRecord;
	};

/* MSGTOIDX.BBS or MSGTOIDX.DAT*/

struct  MsgToIdxRecord
	{
	StringDef35     MsgToIdxRecord;
	};

/* MSGTXT.BBS or MSGTXT.DAT */

struct  MsgTxtRecord
	{
	StringDef255    MsgTxtRecord;
	};

/*  Nodelist Records  */

/* NODEIDX.DAT */

struct  NodeIdxRecord
	{
	NodeTypes       NodeType;
	Word            Number;
	Word            Cost;
	Byte            RawFile;
	LongInt         RawPos;
	};

/* NODEINC.DAT */

struct  NodeIncRecord
	{
	FileNameType    FileName;
	LongInt         DateStamp;
	};

/* Message Records */

/* MSGINFO.BBS or MSGINFO.DAT */

struct  InfoRecord
	{
#ifdef GOLDBASE
	LongInt         LowMsg;            /* Lowest message in file.   */
	LongInt         HighMsg;           /* Highest message in file.  */
	LongInt         TotalActive;       /* Total active messages.    */
	Word            ActiveMsgs[500];
#else
	Integer         LowMsg;            /* Lowest message in file.   */
	Integer         HighMsg;           /* Highest message in file.  */
	Integer         TotalActive;       /* Total active messages.    */
	Integer         ActiveMsgs[200];
#endif
	};

/* MSGIDX.BBS or MSGIDX.DAT */

struct  IdxRecord
	{
#ifdef GOLDBASE
	LongInt         MsgNum;
	Word            Board;
#else
	Integer         MsgNum;
	Byte            Board;
#endif
	};

/* MSGHDR.BBS or MSGHDR.DAT */

struct  HdrRecord
	{
#ifdef GOLDBASE
	LongInt         MsgNum;
	LongInt         ReplyTo;
	LongInt         SeeAlsoNum;
#else
	Integer         MsgNum;
	Integer         ReplyTo;
	Integer         SeeAlsoNum;
#endif
	Integer         TRead;
#ifdef GOLDBASE
	LongInt         StartRec;
#else
	Word            StartRec;
#endif
	Integer         NumRecs;
	Integer         DestNet;
	Integer         DestNode;
	Integer         OrigNet;
	Integer         OrigNode;
	Byte            DestZone;
	Byte            OrigZone;
	Integer         Cost;
#ifdef GOLDBASE
	Word            MsgAttr;
	Word            NetAttr;
	Word            Board;
#else
	Byte            MsgAttr;
	Byte            NetAttr;
	Byte            Board;
#endif
	StringDef5      PostTime;
	StringDef8      PostDate;
	StringDef35     WhoTo;
	StringDef35     WhoFrom;
	StringDef72     Subj;
	};

/* Msg Attributes:

      Bit 0: Deleted
      Bit 1: Unmoved Outgoing Net Message
      Bit 2: Is a Net Mail Message
      Bit 3: Private
      Bit 4: Received
      Bit 5: Unmoved Outgoing Echo Message
      Bit 6: Local Bit
      Bit 7: Group Message

   Net Attributes:

      Bit 0: Kill Message after it's been sent
      Bit 1: Sent OK
      Bit 2: File(s) Attached
      Bit 3: Crash Priority
      Bit 4: Request Receipt
      Bit 5: Audit Request
      Bit 6: Is a Return Receipt
      Bit 7: Freq

*/

/*  Other Stuff */

/* SYSINFO.BBS */

struct  SysInfoRecord
	{
	LongInt         CallCount;
	StringDef35     LastCaller;
	StringDef35     LastCallerAlias;
	Byte            ExtraSpace[92];
	};

/* TODAY.BBS */

struct  TodayRecord
	{
	StringDef35     Name;
	StringDef35     Alias;
	Byte            Line;
	StringDef25     City;
	LongInt         Date;
	LongInt         Time;
	};

/* TIMELOG.BBS */

struct  TimeLogRecord
	{
	StringDef8      StartDate;
	Integer         BusyPerHour[24];
	Integer         BusyPerDay[7];
	};

/* Menu Structure */

/* TOP.MNU (Etc.) */

/*

Menus files will screw you up if you don't understand that they aren't
completely consistent. The first record is NOT a menu item. It's really
the prompt and highlight information. For the first record, the info is
actually:

struct  MenuRecord              First Record
	{
	Byte            Typ;    Highlight Foreground
	Word            Sec;    Highlight Background
	FlagType        Flags;  Not Used
	StringDef75     Str;    Menu Prompt
	Char            Key;    Not Used
	StringDef80     Data;   Not Used
	Byte            Fg;     Menu Prompt Foreground
	Byte            Bg;     Menu Prompt Background
	};

*/

/* Normal menu structure (2nd record to end of menu) */

struct  MenuRecord
	{
	Byte            Typ;
	Word            Sec;
	FlagType        Flags;
	StringDef75     Str;
	Char            Key;
	StringDef80     Data;
	Byte            Fg;
	Byte            Bg;
	};

struct  MenuHelpCfg_Rec
	{
	StringDef37     Description;   /* Visible Help Descrpt.           */
	StringDef37     Options;       /* Visible "Options" For Menu Type */
	StringDef75     Visible_Line;  /* Menu's Visible Line             */
	StringDef80     Optional_Data; /* Menu's Optional Data            */
	Boolean         ImportOkay;
	Word            Menu_Type;     /* Menu Type to be imported        */
		  SecurityRecord  Security;
	Char            Hot_Key;
	Byte            ForeGround;
	Byte            BackGround;
	Byte            Group;
	};

/* ENGLISH.LNG (Etc.) */

struct  PhraseRecord
	{
	StringDef80     TextString;
	StringDef10     KeyString;
	Byte            Color;
	};

/* FILECFG.DAT */

struct  FileAreaRecord
	{
	StringDef66     AreaName;
	StringDef66     FileName;
	StringDef66     ListName;
	Boolean         AllowUploads;
	Boolean         IgnoreKlimit;
	Boolean         IgnoreRatio;
	SecurityRecord  DLSec;
	SecurityRecord  SearchSec;
	SecurityRecord  TemplateSec;
	Boolean         CheckDupes;
	Byte            Group;
	Byte            Spare[10];
	};

/* MSGCFG.DAT */

struct  BoardRecord
	{
	StringDef40     Name;
	TypeMsgs        Typ;
	KindMsgs        Kinds;
	Boolean         Combined;
	AskType         Aliases;
	Byte            Aka;
	StringDef58     OriginLine;
	Boolean         AllowDelete;
	Word            KeepCnt;
	Word            KillRcvd;
	Word            KillOld;
	SecurityRecord  ReadSec;
	SecurityRecord  WriteSec;
	SecurityRecord  TemplateSec;
	SecurityRecord  SysopSec;
	Integer         FileArea;
	Byte            Group;
	Byte            Spare[9];
	};

/* EVENTCFG.DAT */

struct  EventRecord
	{
	EventStat       Status;
	LongInt         RunTime;
	Byte            ErrorLevel;
	Byte            Days;
	Boolean         Forced;
	LongInt         LastTimeRun;
	Byte            Spare[7];
	};

/* LIMITS.DAT */

struct  LimitRecord
	{
	Word                    Security;
	Integer                 DailyLimit;
	Integer                 SessionLimit;
	Integer                 DownLimit;
	Byte                    PwdLife;
	Word                    MinBaud;
	FileKLimitRecord        FileKLimits[8];
	Integer                 FileKRatio;
	Integer                 FileRatio;

	/* Questionaire to run when subscription expires */

	StringDef8              ExpireQuest;

	/* Text File to display when subscription expires soon */

	StringDef8              ExpireText;

	/* Number of days before expiration to start displaying ExpireText */

	Byte                    DaysWarning;
	StringDef40             Description;
	StringDef8              TopMenu;

	/* For UserPack - delete users who haven't called in this many days */

	Byte                    UserPurge;
	FileKLimitRecord        MoreFileKLimits[4];
	Byte                    Spare[3];
	};

/* PROTOCOL.DAT */

struct  ProtocolRecord
	{
	StringDef25             Name;
	Char                    Key;
	ProtocolTypes           ProtocolType;
	Char                    LogCharacter;
	ProtocolEnableType      UploadsAllowed;
	ProtocolEnableType      DownloadsAllowed;
	StringDef66             LogFile;
	StringDef66             ControlFile;
	StringDef100            UploadCommand;
	StringDef100            UploadControl;
	StringDef100            DownloadCommand;
	StringDef100            DownloadControl;
	Boolean                 SupportsBatch;
	Byte                    FileNamePos;
	StringDef20             UploadKeyword;
	StringDef20             DownloadKeyword;
	Byte                    SuccessErrorLevel;
	Byte                    FailureErrorLevel;
	Byte                    Efficiency;
	Byte                    Spare[100];
	};

/* LANGUAGE.DAT */

struct  LanguageRecord
	{
	StringDef20     DisplayName;
	StringDef5      IEMSIName;
	Boolean         Available;
	StringDef66     PhraseFilePath;
	StringDef66     MenuPath;
	StringDef66     TextPath;
	StringDef66     QuestPath;
	Byte            Spare[200];
	};

/* NODECFG.DAT */

struct  NodeConfigRecord
	{
	Byte                    Node;

/*      Modem Parameters  */

	Integer                 CommPort;
	Word                    InitBaud;
	Word                    ModemDelay;
	Integer                 InitTimes;
	Integer                 AnswerWait;
	StringDef70             ModemInitStr;
	StringDef70             ModemBusyStr;
	StringDef40             ModemInitResp;
	StringDef40             ModemBusyResp;
	ModemTranslationRecord  ModemConnectResp[20];
	Word                    CBV_CallbackDelay;
	Word                    CBV_WakeupDelay;
	StringDef8              ARQ_String;
	Boolean                 SendATA;
	StringDef66             SwapPath;
	StringDef58             OriginLine;
	Integer                 MinBaud;
	Integer                 GraphicsBaud;
	Integer                 XferBaud;

/*      Callback Verifier */

	StringDef35             VerifierInit;
	StringDef15             DialString;
	StringDef15             DialSuffix;

/*      Default Information For New Users  */

	SecurityRecord          DefaultSec;
	SecurityRecord          MinimumSec;
	Integer                 DefaultCredit;
	Byte                    ExtraSpace[200];
	};

/* QUICKCFG.DAT */

struct  ConfigRecord
	{
	Word                    VersionID;
	Byte                    WasNodeInfo[481];

/*      System Paths  */

	StringDef70             EditorCmdStr;
	StringDef66             Stat6Line1;
	StringDef66             Stat6Line2;
	StringDef66             NetPath;
	StringDef66             NodelistPath;
	StringDef66             MsgPath;
	StringDef66             OldSwapPath;
	StringDef66             OverlayPath;
	Byte                    OldPrompts[213];

/*      System Miscellaneous strings */

	StringDef58             OldOriginLine;
	StringDef3              QuoteStr;

/*      User Restrictions */

	LongInt                 LowBaudStart;
	LongInt                 LowBaudEnd;
	LongInt                 DownloadStart;
	LongInt                 DownloadEnd;
	Integer                 MaxPageTimes;
	Integer                 PageBellLen;
	LongInt                 PagingStart;
	LongInt                 PagingEnd;
	Byte                    OldBaudStuff[6];

/*      Matrix Information */

	Integer                 MatrixZone[11];
	Integer                 MatrixNet[11];
	Integer                 MatrixNode[11];
	Integer                 MatrixPoint[11];
	Integer                 NetMailBoard;

/*      Old Default Information For New Users  */

	Byte                    OldNewUserInfo[14];

/*      Sysop Security And Sysop Information */

	SecurityRecord          SysopSecurity;
	StringDef35             SysopName;
	StringDef40             SystemName;
	LongInt                 RegKey;

/*      Misc System Parameters  */

	Boolean                 TextFileShells;
	Boolean                 AltJswap;
	Boolean                 Editorswap;
	Boolean                 AutoLogonChar;
	Boolean                 FastLogon;
	Boolean                 UseLastRead;
	Boolean                 MonoMode;
	Boolean                 DirectWrite;
	Boolean                 SnowCheck;
	Boolean                 NetEchoExit;
	Boolean                 OneWordNames;
	Boolean                 CheckMail;
	Boolean                 AskHomePhone;
	Boolean                 AskDataPhone;
	Boolean                 AskBirthday;
	Boolean                 AskSex;
	Boolean                 Use_Xmodem;
	Boolean                 Use_Xmodem1k;
	Boolean                 Use_Ymodem;
	ProtocolEnableType      Use_YmodemG;
	Boolean                 Use_Kermit;
	Boolean                 Use_Zmodem;
	Boolean                 Inp_Fields;
	Boolean                 GraphicsAvail;
	Boolean                 ForceUS_Phone;
	Integer                 InactiveTimeOut;
	Integer                 LogonTime;
	Integer                 DefFgColor;
	Integer                 DefBgColor;
	Integer                 PassWordTries;
	Byte                    EntFldColor; /* Color for entry fields */
	Byte                    BorderColor; /* Color for menu borders */
	Byte                    WindowColor;
	Byte                    StatusBarColor;
	Integer                 UploadCredit;
	Byte                    ScreenBlank;

/*      Callback Verifier */

	Byte                    CBV_Spare[68];
	Boolean                 DupeCheck;
	Word                    NewUserSec;
	Word                    MemberSec;
	Char                    MemberFlags[4][8];
	Word                    LDcost;
	Boolean                 LDenable;
	Boolean                 ResumeLocal;
	Boolean                 ResumeLD;
	LongInt                 LDstart;
	LongInt                 LDend;
	Byte                    ForgotPwdBoard;
	Boolean                 WasSendATA;
	StringDef60             Location;
	Boolean                 ArchiveNetMail;
	Boolean                 IEMSI;
	Boolean                 IEMSI_New;
	Boolean                 AutoAnsi;
	Boolean                 MultiNode;
	Boolean                 AutoLogChat;
	StringDef70             UserEditor;
	Byte                    FileAreaCols;
	Byte                    MsgAreaCols;
	Word                    NewUserExpiry;
	Byte                    PasswordLength;
	Boolean                 ShowIdle;
	StringDef3              LocalRipExt;
	Key4Type                Key4;
	Byte                    ExtraSpace[242];
	};

/* EXITINFO.BBS */

struct  ExitRecord
	{
	Integer         BaudRate;
	SysInfoRecord   SysInfo;
	TimeLogRecord   TimeLogInfo;
	UserRecord      UserInfo;
	EventRecord     EventInfo;
	Boolean         NetMailEntered;
	Boolean         EchoMailEntered;
	StringDef5      LoginTime;
	StringDef8      LoginDate;
	Integer         TmLimit;
	LongInt         LoginSec;
	LongInt         Credit;
	Integer         UserRecNum;
	Word            ReadThru;
	Integer         PageTimes;
	Integer         DownLimit;
	Boolean         WantChat;
	Byte            GosubLevel;
	GosubDataType   GosubData;
	StringDef8      Menu;
	Boolean         ScreenClear;
	Boolean         MorePrompts;
	Boolean         GraphicsMode;
	Boolean         ExternEdit;
	Integer         ScreenLength;
	Boolean         MNP_Connect;
	StringDef48     ChatReason;
	Boolean         ExternLogoff;
	Boolean         ANSI_Capable;
	Byte            CurrentLanguage;
	Boolean         RIP_Active;
	Byte            ExtraSpace[199];
	};
